<script lang="ts">
import Vue from 'vue';
import { SolutionsVideoModal } from '../solutions/index.vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

export default Vue.extend({
  name: 'TabbedCaseStudies',
  components: {
    SolutionsVideoModal,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    quotes: {
      type: Array,
      required: true,
      default() {
        return [];
      },
    },
    controls: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      tabs: [],
      firstTab: null,
      lastTab: null,
      tabpanels: [],
      selectedTab: 0,
      modal: {
        open: false,
        href: null,
      },
    };
  },
  methods: {
    onTabChange(value: number) {
      this.selectedTab = value;
    },
    handleClick(buttonData: any) {
      if (buttonData.modal) {
        this.modal.open = true;
        this.modal.href = buttonData.url;
        if (this.modal.href.includes('vimeo')) {
          setTimeout(() => {
            window.__vimeoRefresh();
          }, 3000);
          // Make sure Vimeo analytics work:
          // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
        }
      }
    },
    closeModal() {
      this.modal.open = false;
    },
    prev() {
      if (this.selectedTab === 0) {
        this.selectedTab = this.quotes.length - 1;
      } else {
        this.selectedTab -= 1;
      }
    },
    next() {
      if (this.selectedTab === this.quotes.length - 1) {
        this.selectedTab = 0;
      } else {
        this.selectedTab += 1;
      }
    },
  },
});
</script>

<template>
  <section class="tabbed-case-studies">
    <SlpContainer>
      <div class="tabbed-case-studies__wrapper">
        <div
          class="tabbed-case-studies__tabs"
          role="tablist"
          aria-labelledby="tablist-1"
        >
          <SlpButton
            v-for="(tab, tabIndex) in quotes"
            :id="`case-study-tab-${tabIndex}`"
            :key="tab.header"
            ref="tab"
            variant="icon"
            type="button"
            role="tab"
            :aria-selected="selectedTab == tabIndex"
            :aria-controls="`case-study-tabpanel-${tabIndex}`"
            class="tabbed-case-studies__tab"
            :class="
              selectedTab == tabIndex ? 'tabbed-case-studies__tab--active' : ''
            "
            :data-ga-name="tab.data_ga_name"
            :data-ga-location="tab.data_ga_location"
            @click.native="onTabChange(tabIndex)"
          >
            <img
              v-if="tab.logo"
              :src="tab.logo.url"
              :alt="tab.logo.alt"
              loading="lazy"
            />
            {{ tab.data_ga_name ?? tab.company }}
          </SlpButton>
        </div>

        <div
          v-for="(caseStudy, caseStudyIndex) in quotes"
          v-show="caseStudyIndex === selectedTab"
          :id="`case-study-tabpanel-${caseStudyIndex}`"
          :key="`tab-content-${caseStudyIndex}`"
          role="tabpanel"
          tabindex="0"
          :aria-labelledby="`case-study-tab-${caseStudyIndex}`"
          class="tabbed-case-studies__content"
          :class="
            selectedTab == caseStudyIndex
              ? 'tabbed-case-studies__content--active'
              : ''
          "
        >
          <SlpRow>
            <SlpColumn :col="6" class="slp-mr-md-32">
              <SlpTypography
                variant="heading3-bold"
                tag="div"
                class="slp-mb-48"
              >
                <p v-html="caseStudy.header"></p>
              </SlpTypography>
              <div v-if="caseStudy.statistic_samples">
                <div
                  v-for="stat in caseStudy.statistic_samples"
                  :key="stat.data.highlight"
                  class="tabbed-case-studies__pill"
                >
                  <SlpIcon
                    v-if="stat.data.icon?.name"
                    :name="stat.data.icon.name"
                    :variant="stat.data.icon.variant"
                    :size="stat.data.icon.size"
                    slp-color="accent-500"
                    class="slp-mr-4"
                  />
                  <SlpTypography
                    tag="h5"
                    variant="heading4-bold"
                    class="slp-mr-8"
                  >
                    <span v-html="stat.data.highlight"></span
                  ></SlpTypography>
                  <SlpTypography tag="p" variant="body3-bold">
                    {{ stat.data.subtitle }}</SlpTypography
                  >
                </div>
              </div>
              <div class="slp-mt-32 tabbed-case-studies__button-container">
                <SlpButton
                  v-if="caseStudy.modal"
                  variant="tertiary"
                  :data-ga-name="caseStudy.data_ga_name"
                  :data-ga-location="caseStudy.data_ga_location"
                  @click.native="handleClick(caseStudy)"
                  >{{ caseStudy.cta_text }}
                  <SlpIcon
                    name="play-circle-outline"
                    variant="marketing"
                    size="md"
                    class="tabbed-case-studies__button-icon"
                  />
                </SlpButton>
                <SlpButton
                  v-else-if="caseStudy.cta_text"
                  variant="tertiary"
                  :href="caseStudy.url"
                  :data-ga-name="caseStudy.data_ga_name"
                  :data-ga-location="caseStudy.data_ga_location"
                >
                  {{ caseStudy.cta_text }}
                  <SlpIcon
                    name="chevron-right"
                    variant="product"
                    size="md"
                    class="tabbed-case-studies__button-icon"
                  />
                </SlpButton>
              </div>
            </SlpColumn>
            <SlpColumn :col="6">
              <div
                v-if="caseStudy.main_video"
                class="tabbed-case-studies__main-video"
              >
                <lite-vimeo
                  data-aos="fade"
                  data-aos-duration="500"
                  :videoid="
                    getVimeoVideoId(createVideoSource(caseStudy.main_video))
                  "
                  autoplay
                ></lite-vimeo>
              </div>
              <div v-else class="tabbed-case-studies__card">
                <div class="tabbed-case-studies__quote">
                  <svg
                    xmlns="http://www.w3.org/2000/svg"
                    width="33"
                    height="28"
                    viewBox="0 0 33 28"
                    fill="none"
                  >
                    <path
                      d="M7.52 27.8C5.06667 27.8 3.2 26.8667 1.92 25C0.64 23.1333 0 20.5733 0 17.32C0 13.5333 0.933333 10.2 2.8 7.32C4.66667 4.44 7.52 2.06667 11.36 0.199997L13.92 5.32C11.52 6.49333 9.70667 7.90666 8.48 9.56C7.30667 11.16 6.72 13.1333 6.72 15.48C6.82667 15.4267 6.96 15.4 7.12 15.4C7.28 15.4 7.41333 15.4 7.52 15.4C9.22667 15.4 10.6667 15.9333 11.84 17C13.0667 18.0133 13.68 19.4267 13.68 21.24C13.68 23.2133 13.0933 24.8133 11.92 26.04C10.7467 27.2133 9.28 27.8 7.52 27.8ZM26.48 27.8C24.0267 27.8 22.16 26.8667 20.88 25C19.6 23.1333 18.96 20.5733 18.96 17.32C18.96 13.5333 19.8933 10.2 21.76 7.32C23.6267 4.44 26.48 2.06667 30.32 0.199997L32.88 5.32C30.48 6.49333 28.6667 7.90666 27.44 9.56C26.2667 11.16 25.68 13.1333 25.68 15.48C25.7867 15.4267 25.92 15.4 26.08 15.4C26.24 15.4 26.3733 15.4 26.48 15.4C28.1867 15.4 29.6267 15.9333 30.8 17C32.0267 18.0133 32.64 19.4267 32.64 21.24C32.64 23.2133 32.0533 24.8133 30.88 26.04C29.7067 27.2133 28.24 27.8 26.48 27.8Z"
                      fill="#171321"
                    />
                  </svg>
                  <SlpTypography tag="p" variant="body1">
                    {{ caseStudy.quote }}</SlpTypography
                  >
                  <div class="tabbed-case-studies__author">
                    <SlpTypography
                      tag="p"
                      variant="body3-bold"
                      class="slp-mt-32"
                    >
                      {{ caseStudy.author }}</SlpTypography
                    >
                    <SlpTypography tag="p" variant="body3">
                      {{ caseStudy.role }}</SlpTypography
                    >
                    <SlpTypography tag="p" variant="body3">
                      {{ caseStudy.company }}</SlpTypography
                    >
                  </div>
                </div>
                <div
                  v-if="caseStudy.main_img.url"
                  class="tabbed-case-studies__headshot"
                >
                  <img
                    :src="caseStudy.main_img.url"
                    :alt="caseStudy.main_img.alt"
                    loading="lazy"
                  />
                </div>
              </div>
            </SlpColumn>
          </SlpRow>
        </div>
      </div>
    </SlpContainer>
    <SolutionsVideoModal
      v-show="modal.open"
      light-background
      :visible="modal.open"
      @close="closeModal"
    >
      <template #body>
        <lite-vimeo
          :videoid="modal.href"
          :videotitle="modal.video_title ?? 'Video player'"
          autoplay
        ></lite-vimeo>
      </template>
    </SolutionsVideoModal>
    <div class="tabbed-case-studies__controls">
      <SlpButton
        variant="icon"
        class="tabbed-case-studies__prev"
        @click.native="prev()"
      >
        <SlpIcon name="chevron-left" variant="product" size="md" />
        {{ controls.prev }}
      </SlpButton>
      <ul class="tabbed-case-studies__list">
        <li
          v-for="(caseStudyControl, caseStudyControlIndex) in quotes"
          :key="`control-${caseStudyControlIndex}`"
          class="tabbed-case-studies__item"
        >
          <SlpButton
            variant="icon"
            @click.native="onTabChange(caseStudyControlIndex)"
          >
            <div
              class="tabbed-case-studies__control"
              :class="
                selectedTab == caseStudyControlIndex
                  ? 'tabbed-case-studies__control--active'
                  : ''
              "
            ></div>
            {{ caseStudyControlIndex }}
          </SlpButton>
        </li>
      </ul>
      <SlpButton
        variant="icon"
        class="tabbed-case-studies__next"
        @click.native="next()"
      >
        <SlpIcon name="chevron-right" variant="product" size="md" />
        {{ controls.next }}
      </SlpButton>
    </div>
  </section>
</template>

<style lang="scss" scoped>
.tabbed-case-studies {
  margin: $spacing-64 auto;

  @media screen and (min-width: $breakpoint-sm) {
    margin: $spacing-64 auto;
  }
  @media screen and (min-width: $breakpoint-sm) {
    margin: $spacing-96 auto;
  }
  &__tab {
    margin-right: $spacing-32;
    border: none;
    position: relative;
    cursor: pointer;
    padding-bottom: $spacing-24;
    z-index: 1;
    height: 74px;
    img {
      max-height: 42px;
      max-width: 164px;
    }
    &:after {
      content: '';
      position: absolute;
      height: 4px;
      width: 100%;
      background-color: $color-accent-500;
      right: 0;
      left: 0;
      bottom: 0;
      transform: scaleX(0);
      opacity: 0;
      transition:
        transform 0.3s ease,
        opacity 0.3s ease;
      transform-origin: right;
    }
    &--active {
      &:after {
        transform: scaleX(1);
        transform-origin: left;
        opacity: 1;
      }
    }
  }
  &__tabs {
    margin-bottom: $spacing-32;
    display: flex;
    align-items: center;
    justify-content: space-between;
    position: relative;
    overflow-x: scroll;
    margin-right: -16px;
    &::-webkit-scrollbar {
      display: none;
      scrollbar-width: none;
    }
    &:after {
      content: '';
      position: absolute;
      height: 4px;
      width: 100%;
      background-color: $color-surface-100;
      right: 0;
      left: 0;
      bottom: 0;
      min-width: 900px;
    }
    @media screen and (min-width: $breakpoint-sm) {
      margin-bottom: $spacing-64;
      margin-right: auto;
    }
  }
  &__card {
    margin-top: 32px;
    margin-bottom: 32px;
    position: relative;
    @media screen and (min-width: $breakpoint-sm) {
      margin-top: 0;
    }
  }
  &__pill {
    display: flex;
    border-radius: 90px;
    background: $color-surface-800;
    margin-top: 16px;
    padding: $spacing-8 $spacing-24;
    width: 100%;
    align-items: center;
    @media screen and (min-width: $breakpoint-sm) {
      width: 80%;
    }
  }
  &__quote {
    border-radius: 8px;
    background: $color-surface-800;
    margin-right: 40px;
    padding: $spacing-24;
    @media screen and (min-width: $breakpoint-sm) {
      padding: $spacing-48;
    }
  }
  &__headshot {
    border-radius: 4.4px 4.4px 60px 4.4px;
    background: black;
    width: 154px;
    height: 154px;
    position: absolute;
    right: 0;
    bottom: -62px;
    overflow: hidden;
    @media screen and (min-width: $breakpoint-sm) {
      bottom: -32px;
    }
    img {
      width: 100%;
      height: 100%;
      object-fit: cover;
    }
  }
  &__content {
    &--active {
      animation: fade-in 0.5s ease-in forwards;
    }
  }
  &__button-icon {
    height: 20px;
    width: 20px;
  }
  &__control-icon {
    height: 24px;
    width: 24px;
  }
  &__controls {
    display: flex;
    align-items: center;
    margin-top: 96px;
    width: 100%;
    justify-content: center;
    @media screen and (min-width: $breakpoint-sm) {
      display: none;
    }
  }
  &__list {
    display: flex;
    :deep .slp-btn {
      padding: 0;
      width: 10px;
      min-width: 10px;
    }
  }
  &__item {
    display: flex;
    align-items: center;
    margin: 0px 16px;
  }
  &__control {
    height: 10px;
    width: 10px;
    border-radius: 10px;
    background: $color-surface-300;
    cursor: pointer;
    transition: all 0.3s ease;
    &--active {
      background: $color-surface-700;
    }
  }
  &__prev,
  &__next {
    padding: 0;
    min-width: auto;
  }
  &__prev {
    :deep &.slp-btn-tertiary:hover .slp-icon {
      transform: translateX(-8px);
    }
  }
  &__button-container {
    position: absolute;
    bottom: -64px;
    @media screen and (min-width: $breakpoint-sm) {
      position: relative;
      bottom: auto;
    }
  }
  &__main-video {
    height: 368px;
    padding-left: $spacing-24;

    lite-vimeo {
      height: 100%;
      width: 100%;
      border-radius: 4px 4px 90px 4px;
    }
  }
  @keyframes fade-in {
    from {
      opacity: 0;
      transform: translateY(10px);
    }
    to {
      opacity: 1;
      transform: translateY(0);
    }
  }
  &__author {
    margin-right: 106px;
  }
}
</style>
